<?php
/*
Plugin Name: fortunate
Plugin URI: http://mickdakota.com/wordpress-fortune-plugin
Description: Puts random quotation (fortune cookie) on page
Author: Mick Dakota
Version: 1.3.1
Author URI: http://mickdakota.com
*/

/*
Copyright 2008-2009 Mick Dakota. All rights reserved.

Redistribution and use in source and binary forms, with or without 
modification, are permitted provided that the following conditions are met:

   1. Redistributions of source code must retain the above copyright notice, 
this list of conditions and the following disclaimer.
   2. Redistributions in binary form must reproduce the above copyright 
notice, this list of conditions and the following disclaimer in the 
documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY Mick Dakota ``AS IS'' AND ANY EXPRESS OR IMPLIED 
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL Mick Dakota OR ANY PROJECT CONTRIBUTORS BE LIABLE FOR ANY 
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND 
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/


$fortunate_echo = true;

add_option('fortunate_lang'     , 'en'      , '' , 'yes');
add_option('fortunate_type'     , ''         , '' , 'yes');
add_option('fortunate_length'   , '0'        , '' , 'yes');
add_option('fortunate_numlines' , '0'        , '' , 'yes');
add_option('fortunate_location' , 'loop_end' , '' , 'yes');
add_option('fortunate_title'    , 'Fortune Cookie'  , '' , 'yes');
add_option('fortunate_addcss'   , '0'        , '' , 'yes');

if(get_option('fortunate_addcss') == "1")   
  add_action('wp_head','fortunate_css');

add_action('admin_menu', 'fortunate_plugin_menu');

$fortunate_location = get_option('fortunate_location');
if($fortunate_location == 'widget')
  add_action('plugins_loaded', 'fortunate_widget_init');
elseif($fortunate_location == 'bloginfo')
  add_filter('bloginfo','fortunate_filter',10,2);
else
  add_action($fortunate_location,'fortunate',1);


function fortunate_widget_init() {
  register_sidebar_widget('Fortunate', 'fortunate_widget');
}


function fortunate_plugin_menu() {
  add_options_page('Fortunate Plugin Options', 'Fortunate', 
    8, __FILE__, 'fortunate_plugin_options');
}

function fortunate_plugin_options() {

  if($_SERVER['REQUEST_METHOD'] == 'POST') {
    // Save settings
    update_option('fortunate_lang',$_POST['fortunate_lang']);
    update_option('fortunate_type',$_POST['fortunate_type']);
    update_option('fortunate_length',$_POST['fortunate_length']);
    update_option('fortunate_numlines',$_POST['fortunate_numlines']);
    update_option('fortunate_location',$_POST['fortunate_location']);
    update_option('fortunate_title',$_POST['fortunate_title']);
    if($_POST['fortunate_addcss'] == "1")
      update_option('fortunate_addcss',"1");
    else
      update_option('fortunate_addcss',"0");


    echo "<div class=\"updated\"><p><strong>"; 
    echo __('Options saved.', 'fortunate_plugin_domain' );
    echo "</strong></p></div>";
  }

    $fortunate_lang = get_option('fortunate_lang');
    $fortunate_type = get_option('fortunate_type');
    $fortunate_length = intval(get_option('fortunate_length'));
    $fortunate_numlines = intval(get_option('fortunate_numlines'));
    $fortunate_location = get_option('fortunate_location');
    $fortunate_title = get_option('fortunate_title');    
    $fortunate_addcss = get_option('fortunate_addcss');

    // Now display the options editing screen

    echo '<div class="wrap">';
    echo "<h2>" . __( 'Fortunate  Plugin Options', 'fortunate_plugin_domain' ) . "</h2>";
    echo "<p>&copy; <a href=\"http://mickdakota.com\">Mick Dakota</a></p>";

    // options form

   echo "<form name=\"form1\" method=\"post\" action=\"" 
     .str_replace( '%7E', '~', $_SERVER['REQUEST_URI']). "\">";

  $fortunate_lang_text = __('Select a quotation language.', 'fortunate_plugin_domain');

   echo "<p>$fortunate_lang_text</p><p>";

   $langs = array('en' => __('English', 'fortunate_plugin_domain'),
                  'es' => __('Spanish', 'fortunate_plugin_domain'),
                  'it' => __('Italian', 'fortunate_plugin_domain'),
                  'fr' => __('French',  'fortunate_plugin_domain'),
                  'de' => __('German',  'fortunate_plugin_domain'),
                  'ru' => __('Russian', 'fortunate_plugin_domain'));
  
   echo __("Language:", 'fortunate_plugin_domain');
   echo "<select name=\"fortunate_lang\">";
   foreach($langs as $k => $v) {
     echo "<option value=\"$k\""
      . (($fortunate_lang == $k) ? " selected=\"selected\" " : "")
      . ">$v</option>";
   }   
   echo "</select></p>";

   $fortunate_location_text1 = __('Select a location on the page to display the random quotes. Some locations may require css modifications appropriate to your selected theme.', 'fortunate_plugin_domain'); 

   $fortunate_location_text2 = __('Selecting \'Widget\' for the location requires an additional step: once these options are saved, go to your <a href="widgets.php">widget administration page</a> and add the widget to the desired location on the sidebar.','fortunate_plugin_domain');

   $fortunate_location_text3 = __('Selecting \'Header - description\' will add the quote text to the blog description, which is generally on your page header. This works best when used with 1 for \'Maximum number of lines\' (below).','fortunate_plugin_domain');

   echo "<hr /><p>$fortunate_location_text1</p><p>$fortunate_location_text2</p><p>$fortunate_location_text3</p><p>";

   echo __("Where to display:", 'fortunate_plugin_domain');
   echo "<select name=\"fortunate_location\">";
   echo "<option value=\"loop_end\""
      . (($fortunate_location == 'loop_end') ? " selected=\"selected\" " : "")
      . ">" 
      . __('Page Content Area','fortunate_plugin_domain') 
      . "</option>";  
   echo "<option value=\"bloginfo\""
      . (($fortunate_location == 'bloginfo') ? " selected=\"selected\" " : "")
      . ">"
      . __('Header - description','fortunate_plugin_domain')
      . "</option>";   
   echo "<option value=\"wp_footer\""
      . (($fortunate_location == 'wp_footer') ? " selected=\"selected\" " : "")
      . ">"
      . __('Footer','fortunate_plugin_domain')
      . "</option>";   
   echo "<option value=\"widget\""
      . (($fortunate_location == 'widget') ? " selected=\"selected\" " : "")
      . ">"
      . __('Widget','fortunate_plugin_domain')
      . "</option>";   

   echo "</select></p>";

   $fortunate_title_text = __('This setting is only used if you selected \'Widget\' above. It allows you to change the sidebar title to your liking.','fortunate_plugin_domain');

   echo "<hr /><p>$fortunate_title_text</p><p>";
   echo __("Fortunate Widget Title:", 'fortunate_plugin_domain');
   echo "<input type=\"text\" size=\"16\" name=\"fortunate_title\"
         value=\"$fortunate_title\" /></p>";

   $fortunate_css_text = __('Include the wp-content/plugins/fortunate/fortunate.css file? Some page locations may require CSS changes to display exactly as you wish. You may make the changes to this file and include it by checking the box below. Alternatively, your theme may display everything just fine and you might not wish to use the additional CSS file at all.','fortunate_plugin_domain');

   echo "<hr /><p>$fortunate_css_text</p><p>";
   echo __("Include plugin CSS file:", 'fortunate_plugin_domain');
   echo "<input type=\"checkbox\" name=\"fortunate_addcss\"";
   echo (($fortunate_addcss == "1") ? " checked=\"checked\" " : "" );
   echo " value=\"1\" /></p>";

   $fortunate_off_text = __('By default, assume that this content is for general audiences and do not include quotations and jokes which are overtly sexual, racial, or otherwise might be deemed offensive. If you change this setting, be aware that members of your audience may be offended or insulted. This setting currently only applies to English, Spanish, and Italian content. Other languages have not yet been content rated and \'Normal\' is the only setting which will work.','fortunate_plugin_domain');

   echo "<hr/><p>$fortunate_off_text</p><p>";
   echo __("Quotation Rating:", 'fortunate_plugin_domain');
   echo "<select name=\"fortunate_type\">";
   echo "<option value=\"\""
      . (($fortunate_type == '') ? " selected=\"selected\" " : "")
      . ">"
      . __('Normal - no offensive/adult','fortunate_plugin_domain')
      . "</option>";   
   echo "<option value=\"a\""
      . (($fortunate_type == 'a') ? " selected=\"selected\" " : "")
      . ">"
      . __('Any - including offensive/adult','fortunate_plugin_domain')
      . "</option>";   
   echo "<option value=\"o\""
      . (($fortunate_type == 'o') ? " selected=\"selected\" " : "")
      . ">"
      . __('Only offensive/adult','fortunate_plugin_domain')
      . "</option>";   
   echo "</select></p>";

   $fortunate_length_text = __('You may restrict results to those that are less than a certain number of characters, as some entries can get quite lengthy. This number is only a guideline as it is applied to the quotation before HTML markup is applied, which might change the length a bit. If you set this in the range of 200-300, you\'ll see more simple quotations and fewer long stories and jokes. For best results, you should probably set this to 0 or something greater than 80.','fortunate_plugin_domain'); 

   echo "<hr /><p>$fortunate_length_text</p><p>";

   echo __("Maximum length in bytes:", 'fortunate_plugin_domain');
   echo "<input type=\"text\" size=\"8\" name=\"fortunate_length\"
         value=\"$fortunate_length\" />"
        . __(' 0 is unlimited','fortunate_plugin_domain')
        . "</p>";
   $fortunate_lines_text1 = __('You may also wish to only display results that are limited to a specific number of text lines (ignoring browser wordwrap)*. This is most useful if the setting is 1 or 2 for use in a limited space, such as on a page header or footer with a fixed height. For best results, you should probably set this to 0, 1, or 2.','fortunate_plugin_domain');

   $fortunate_lines_text2 = __('* A single line from a returned quotation may contain up to 80 characters. If the target page region does not provide enough space for 80 column text, some lines may get wrapped or folded.','fortunate_plugin_domain');

   echo "<hr /><p>$fortunate_lines_text1</p><p>$fortunate_lines_text2</p><p>";

   echo __("Maximum number of lines:", 'fortunate_plugin_domain');
   echo "<input type=\"text\" size=\"8\" name=\"fortunate_numlines\"
         value=\"$fortunate_numlines\" />"
        . __(' 0 is unlimited','fortunate_plugin_domain')
        . "</p>";

   echo "<hr /><p class=\"submit\">"
     . "<input type=\"submit\" name=\"Submit\" value=\"";
   echo __('Update Options', 'fortunate_plugin_domain' ); 
   echo "\" /></p></form></div>";

}


function fortunate_css() {
  echo '<link type="text/css" rel="stylesheet" href="' 
    . get_bloginfo('wpurl') 
    . '/wp-content/plugins/fortunate/fortunate.css" />' 
    . "\n";
}


function fortunate_widget($args) {
  extract($args);
  echo $before_widget;
  echo $before_title;
  echo get_option('fortunate_title');
  echo $after_title;
  fortunate();
  echo $after_widget;
}

function fortunate_filter($info,$req) {
  global $fortunate_echo;
  if($req != 'description')
    return $info;
  $fortunate_echo = false;
  return $info . fortunate();
}

function fortunate() {
  global $fortunate_echo;
  static $fortunate_done = false;
  if($fortunate_done)
    return;
  @include("wp-includes/class-snoopy.php");
  if(class_exists('Snoopy')) {
    $sn = new Snoopy;
    $sn->referer = get_option('home');
    $fortunate_url = "http://fortunemod.com/cookie.php?rand=" . mt_rand();
    $f = get_option('fortunate_lang');
    if($f != 'en')
      $fortunate_url .= "&lang=$f";
    $f = get_option('fortunate_type');
    if($f)
      $fortunate_url .= "&off=$f";
    $f = intval(get_option('fortunate_length'));
    if($f)
      $fortunate_url .= "&length=$f";
    $f = intval(get_option('fortunate_numlines'));
    if($f)
      $fortunate_url .= "&numlines=$f";

    @$sn->fetch($fortunate_url);
    $result = '<div class="fortunate">' . $sn->results . '</div>' . "\n" ;
    $fortunate_done = true;
    if($fortunate_echo)
      echo $result;
    else
      return $result;
  }
}
